'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var React = require('react');

var utilsHooks = require('@highlight-ui/utils-hooks');

var classnames = require('classnames');

var utilsCommons = require('@highlight-ui/utils-commons');

var typography = require('@highlight-ui/typography');

function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */


var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var styles = {
  "text": "Toggle-module__2qI9p5Zj__v1-2-19",
  "toggle": "Toggle-module__24f9_3_p__v1-2-19",
  "disabled": "Toggle-module__3o0O4ZFE__v1-2-19",
  "slide": "Toggle-module__3f9w55tm__v1-2-19",
  "withTitle": "Toggle-module__20TTvcWK__v1-2-19",
  "checkbox": "Toggle-module__3D1IbYuP__v1-2-19",
  "track": "Toggle-module__2-ECk2xU__v1-2-19",
  "checked": "Toggle-module__1wn5hE_a__v1-2-19",
  "titleContainer": "Toggle-module__24zoDkDS__v1-2-19",
  "subTitle": "Toggle-module__2epSsbhB__v1-2-19"
};
var Toggle = React__default["default"].forwardRef(function Toggle(_a, ref) {
  var _b;

  var className = _a.className,
      metadata = _a.metadata,
      disabled = _a.disabled,
      id = _a.id,
      checked = _a.checked,
      onToggle = _a.onToggle,
      title = _a.title,
      subTitle = _a.subTitle;
  var uid = utilsHooks.useId('toggle-');
  var htmlId = id || uid;
  return React__default["default"].createElement("label", __assign({
    ref: ref,
    htmlFor: htmlId
  }, utilsCommons.parseMetadata(metadata), {
    className: classnames__default["default"](className, styles.toggle, (_b = {}, _b[styles.withTitle] = Boolean(title), _b[styles.checked] = checked, _b[styles.disabled] = disabled, _b))
  }), React__default["default"].createElement("span", {
    className: styles.track
  }, React__default["default"].createElement("span", {
    className: styles.slide
  }), React__default["default"].createElement("input", {
    id: htmlId,
    type: "checkbox",
    checked: checked,
    disabled: disabled,
    onChange: onToggle,
    className: styles.checkbox,
    "data-test-id": metadata ? metadata.testId + "-checkbox" : undefined
  })), title && React__default["default"].createElement("span", {
    className: styles.titleContainer
  }, React__default["default"].createElement(typography.Typography, {
    token: "body-base",
    component: "span",
    color: disabled ? 'text-disabled' : 'text-default',
    className: styles.text
  }, title), subTitle && React__default["default"].createElement(typography.Typography, {
    token: "body-small",
    component: "p",
    color: disabled ? 'text-disabled' : 'text-subdued',
    className: classnames__default["default"](styles.text, styles.subTitle)
  }, subTitle)));
});
exports.Toggle = Toggle;
//# sourceMappingURL=index.js.map
